/*!
 * @file dynamic_loader.h
 * @brief Definition of The Dynamic Loader Factory.
*/

#ifndef _DYNAMIC_LOADER_H
#define _DYNAMIC_LOADER_H

#include "util/loading/factory.h"
#include <ltdl.h>

#include <string>

// FORWARD DECLARATION

//! A class for ...
class DynamicLoader : public BaseObject
{

public:
  DynamicLoader(const std::string& libName);
  virtual ~DynamicLoader();

  bool loadDynamicLib(const std::string& libName);

  static bool loadDyLib(const std::string& libName);

  static void addSearchDir(const std::string& searchDir);
  static bool addSearchDirRelative(const std::string& relSearchDir);
  static bool addSearchDirInLibDir(const std::string& relSearchDir);
  static const char* getSearchDir();

  static void unload();
private:
  // will be done automatically when using the this Engine.
  static bool initialize();

private:
  lt_dlhandle      handle;
};

#endif /* _DYNAMIC_LOADER_H */
